/*
 * Basic configuration of kemacs.
 * Further configurations may be done in estruct.h
 */

/* OS definitions */
#define BSD	1			/* UNIX BSD 4.[23]	*/
#define USG	0			/* UNIX system V	*/

/* compiler facility */
#define STRASSOK	1	/* accepts struct/union assignment? */
#define SHORTNAME	0	/* need short name? */

/* OS versions */
/* for BSD */
#define BSD_4_1	1		/* BSD 4.1 or later	*/
#define BSD_4_2	1		/* BSD 4.2 or later	*/
#define BSD_4_3	1		/* BSD 4.3 or later	*/

#define BSD_4_2W	0		/* have SIGWINCH	*/

/* for USG */
#define USG_5_4		0	/* System V R4 */
/* I do not know about USG versions very well... */

/* 1993/7/6 by NIDE, N. */
#define HAVE_VARARGS  1               /* handle varargs */
#define VOID_SIGFN    0               /* 2nd arg of signal() is (void*)() */

/* KANJI usage */
#define KANJI		1		/* use KANJI feature	*/

/* KANJI code defaults */
/* if DEF_*_CODE is not defined, BINARY is assumed. */
/* KI/RI are only needed for JIS */
/* File code */
#define DEF_F_CODE	KS_JIS		/* JIS/UJIS/SJIS	*/
#define DEF_F_KI	KS_NEWJIS	/* OLDJIS/NEWJIS	*/
#define DEF_F_RI	KS_ASCII	/* ROMAJI/ASCII/BOGUS	*/
/* Terminal code */
#define DEF_T_CODE	KS_JIS		/* JIS/UJIS/SJIS	*/
#define DEF_T_KI	KS_NEWJIS	/* OLDJIS/NEWJIS	*/
#define DEF_T_RI	KS_ASCII	/* ROMAJI/ASCII/BOGUS	*/

#define DEF_T_THRU	1		/* can through 8bit?	*/

/* terminal capabilities */
#define KANJI_TERMCAP	"KJ"	/* KANJI capability */
/* if defined, default of disp code and key code are specified through	*/
/*	this capability.						*/
/*	if capability is not in TERMCAP, KANJI feature disabled by	*/
/*	default. if flag capability exist, KANJI enabled and above 	*/
/*	defaults are used. if string capability "XYZ" exist, CODE, KI	*/
/*	and RI are set according to each.				*/
/*	X=j/J/U/S. if X==[Jj], Y & Z are needed. Y=@/B, Z=B/J/H.	*/
/*	If X=J, code is JIS and can through 8bit. X=j means 7bit only.	*/
/*	Other code implies 8bit through (of cource :-P)			*/
/*	e.g. capability of "KJ=j@H" means 7bit only, JIS-OLD-BOGUS	*/
/*	terminal, while "KJ=U" means 8bit UJIS terminal.		*/
/*	Note: Display code and Keyboard code cannot specified		*/
/*	separately in the TERMCAP.					*/
/* if not defined, specifications above are used.			*/

/* Although in BSD environment, some as don't understand -R option */
#define HAVE_AS_R	0	/* 0: no -R, 1: has -R */

/******* end of configuration *******/

/* maintain consistency */
#if BSD
# undef  USG
# define USG		0
# if BSD_4_3
#  undef  BSD_4_2
#  define BSD_4_2	1
# endif
# if BSD_4_2W
#  undef  BSD_4_2
#  define BSD_4_2	1
# endif
# if BSD_4_2
#  undef  BSD_4_1
#  define BSD_4_1	1
# endif
#endif /*BSD*/

#if USG
/* no idea of USG... */
#endif /*USG*/

#if VOID_SIGFN
# define SIGRET_T void
#else
# define SIGRET_T int
#endif
