#include <stdio.h>
#include "kanji.h"

/*
 * kputc:	put 16-bit KANJI codes to the file stream in 7-bit format.
 */

#define NORMAL	0
#define KANJI	1
#define KANA	2

kputc(c, kp)
	register int c;
	register KSTREAM *kp;
{
	int cc;
	static char buf[BUFSIZ];
	register char *p = buf;

	if (!kp->ks_putf) return EOF;
	if (c == EOF) {
	  /* flush pending output and return to normal state */
	  if (KS_INTERP(kp->ks_flag) != KS_BINARY &&
	      KS_CODE(kp->ks_flag) == KS_JIS) {
	    if (kp->ks_pstate & KANA) {
	      *p++ = SHFTIN;
	    }
	    if (kp->ks_pstate & KANJI) {
	      *p++ = ESCAPE;
	      *p++ = '(';
	      *p++ = KS_RI(kp->ks_flag) == KS_ROMAJI? 'J':
		     KS_RI(kp->ks_flag) == KS_ASCII? 'B': 'H';
	    }
	    if (p > buf)
	      (void)(*kp->ks_putf)(kp->ks_id, buf, p-buf);
	  }
	  kp->ks_pstate = NORMAL;
	  return EOF;
	}
	if (KS_INTERP(kp->ks_flag) == KS_BINARY) {
	  buf[0] = c & (KS_THRU(kp->ks_flag)? 0xff: 0x7f);
	  (void)(*kp->ks_putf)(kp->ks_id, buf, 1);
	  return c;
	}
	if (iskanji(c)) {
		switch (KS_CODE(kp->ks_flag)) {
		case KS_JIS:
			if (kp->ks_pstate & KANA) {
				*p++ = SHFTIN;
			}
			if (!(kp->ks_pstate & KANJI)) {
			  *p++ = ESCAPE;
			  *p++ = '$';
			  *p++ = (KS_KI(kp->ks_flag) == KS_NEWJIS)? 'B': '@';
			}
			kp->ks_pstate = KANJI;
			dekanji(c, *p, p[1]);
			p += 2;
			break;
		case KS_UJIS:
			dekanji(c, *p, p[1]);
			*p++ |= 0x80;
			*p++ |= 0x80;
			break;
		case KS_SJIS:
			dekanji(c, *p, p[1]);
			cc = (*p << 8) | p[1];
			jtos(&cc, &cc);
			*p++ = (cc >> 8) & 0xff;
			*p++ = cc & 0xff;
			break;
		}
	} else if (iskana(c)) {
		switch (KS_CODE(kp->ks_flag)) {
		case KS_JIS:
			if (!(kp->ks_pstate & KANA)) {
				*p++ = SHFTOU;
				kp->ks_pstate |= KANA;
			}
			dekana(c, *p);
			p++;
			break;
		case KS_UJIS:
			*p++ = SSHFT2;
			dekana(c, *p);
			*p++ |= 0x80;
			break;
		case KS_SJIS:
			dekana(c, *p);
			*p++ |= 0x80;
			break;
		}
	} else {
		/* ascii (including control) characters */
		if (KS_CODE(kp->ks_flag) == KS_JIS) {
			if (kp->ks_pstate & KANA) {
				*p++ = SHFTIN;
			}
			if (kp->ks_pstate & KANJI) {
			  *p++ = ESCAPE;
			  *p++ = '(';
			  *p++ = KS_RI(kp->ks_flag) == KS_ROMAJI? 'J':
			         KS_RI(kp->ks_flag) == KS_ASCII? 'B': 'H';
			}
			kp->ks_pstate = NORMAL;
		}
		*p++ = c;
	}
	(void)(*kp->ks_putf)(kp->ks_id, buf, p-buf);
	return c;
}
